
        "use strict";

        const conversions = require("webidl-conversions");
        const utils = require("./utils.js");
        
      const HTMLConstructor_helpers_html_constructor = require("../helpers/html-constructor.js").HTMLConstructor;
const ceReactionsPreSteps_helpers_custom_elements = require("../helpers/custom-elements.js").ceReactionsPreSteps;
const ceReactionsPostSteps_helpers_custom_elements = require("../helpers/custom-elements.js").ceReactionsPostSteps;
const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;
const Element = require("./Element.js");

      
      const interfaceName = "HTMLElement";
    
      exports.is = function is(obj) {
        return utils.isObject(obj) && utils.hasOwn(obj, implSymbol) && obj[implSymbol] instanceof Impl.implementation;
      };
      exports.isImpl = function isImpl(obj) {
        return utils.isObject(obj) && obj instanceof Impl.implementation;
      };
      exports.convert = function convert(obj, { context = "The provided value" } = {}) {
        if (exports.is(obj)) {
          return utils.implForWrapper(obj);
        }
        throw new TypeError(`${context} is not of type 'HTMLElement'.`);
      };
    
      exports.create = function create(globalObject, constructorArgs, privateData) {
        if (globalObject[ctorRegistrySymbol] === undefined) {
          throw new Error('Internal error: invalid global object');
        }

        const ctor = globalObject[ctorRegistrySymbol]["HTMLElement"];
        if (ctor === undefined) {
          throw new Error('Internal error: constructor HTMLElement is not installed on the passed global object');
        }

        let obj = Object.create(ctor.prototype);
        obj = exports.setup(obj, globalObject, constructorArgs, privateData);
        return obj;
      };
      exports.createImpl = function createImpl(globalObject, constructorArgs, privateData) {
        const obj = exports.create(globalObject, constructorArgs, privateData);
        return utils.implForWrapper(obj);
      };
      exports._internalSetup = function _internalSetup(obj, globalObject) {
    
        Element._internalSetup(obj, globalObject);
      
      };
      exports.setup = function setup(obj, globalObject, constructorArgs = [], privateData = {}) {
        privateData.wrapper = obj;

        exports._internalSetup(obj, globalObject);
        Object.defineProperty(obj, implSymbol, {
          value: new Impl.implementation(globalObject, constructorArgs, privateData),
          configurable: true
        });
    
        obj[implSymbol][utils.wrapperSymbol] = obj;
        if (Impl.init) {
          Impl.init(obj[implSymbol], privateData);
        }
        return obj;
      };
    
      exports.install = function install(globalObject) {
    
        if (globalObject.Element === undefined) {
          throw new Error('Internal error: attempting to evaluate HTMLElement before Element');
        }
      class HTMLElement extends globalObject.Element {
        constructor() {
      return HTMLConstructor_helpers_html_constructor(globalObject, interfaceName, new.target);
    }
      
        click() {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        if (!exports.is(esValue)) {
          throw new TypeError("Illegal invocation");
        }
      
        return esValue[implSymbol].click();
      }
      
        focus() {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        if (!exports.is(esValue)) {
          throw new TypeError("Illegal invocation");
        }
      
        return esValue[implSymbol].focus();
      }
      
        blur() {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        if (!exports.is(esValue)) {
          throw new TypeError("Illegal invocation");
        }
      
        return esValue[implSymbol].blur();
      }
      
        get title() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "title");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set title(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'title' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "title", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get lang() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "lang");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set lang(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'lang' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "lang", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get translate() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        return esValue[implSymbol]["translate"];
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set translate(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["boolean"](V, { context: "Failed to set the 'translate' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        esValue[implSymbol]["translate"] = V;
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get dir() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        return esValue[implSymbol]["dir"];
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set dir(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'dir' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        esValue[implSymbol]["dir"] = V;
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get hidden() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          return esValue[implSymbol].hasAttributeNS(null, "hidden");
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set hidden(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["boolean"](V, { context: "Failed to set the 'hidden' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          if (V) {
            esValue[implSymbol].setAttributeNS(null, "hidden", "");
          } else {
            esValue[implSymbol].removeAttributeNS(null, "hidden");
          }
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get accessKey() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "accesskey");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set accessKey(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'accessKey' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "accesskey", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get draggable() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        return esValue[implSymbol]["draggable"];
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set draggable(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["boolean"](V, { context: "Failed to set the 'draggable' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        esValue[implSymbol]["draggable"] = V;
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get offsetParent() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["offsetParent"]);
    }
      
        get offsetTop() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["offsetTop"];
    }
      
        get offsetLeft() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["offsetLeft"];
    }
      
        get offsetWidth() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["offsetWidth"];
    }
      
        get offsetHeight() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["offsetHeight"];
    }
      
        get style() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.getSameObject(this, "style", () => { return utils.tryWrapperForImpl(esValue[implSymbol]["style"]); });
    }
      
        set style(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        this.style.cssText = V;
      }
      
        get onabort() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onabort"]);
    }
      
        set onabort(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onabort"] = V;
      }
      
        get onauxclick() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onauxclick"]);
    }
      
        set onauxclick(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onauxclick"] = V;
      }
      
        get onblur() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onblur"]);
    }
      
        set onblur(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onblur"] = V;
      }
      
        get oncancel() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["oncancel"]);
    }
      
        set oncancel(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["oncancel"] = V;
      }
      
        get oncanplay() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["oncanplay"]);
    }
      
        set oncanplay(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["oncanplay"] = V;
      }
      
        get oncanplaythrough() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["oncanplaythrough"]);
    }
      
        set oncanplaythrough(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["oncanplaythrough"] = V;
      }
      
        get onchange() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onchange"]);
    }
      
        set onchange(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onchange"] = V;
      }
      
        get onclick() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onclick"]);
    }
      
        set onclick(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onclick"] = V;
      }
      
        get onclose() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onclose"]);
    }
      
        set onclose(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onclose"] = V;
      }
      
        get oncontextmenu() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["oncontextmenu"]);
    }
      
        set oncontextmenu(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["oncontextmenu"] = V;
      }
      
        get oncuechange() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["oncuechange"]);
    }
      
        set oncuechange(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["oncuechange"] = V;
      }
      
        get ondblclick() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondblclick"]);
    }
      
        set ondblclick(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondblclick"] = V;
      }
      
        get ondrag() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondrag"]);
    }
      
        set ondrag(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondrag"] = V;
      }
      
        get ondragend() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondragend"]);
    }
      
        set ondragend(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondragend"] = V;
      }
      
        get ondragenter() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondragenter"]);
    }
      
        set ondragenter(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondragenter"] = V;
      }
      
        get ondragexit() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondragexit"]);
    }
      
        set ondragexit(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondragexit"] = V;
      }
      
        get ondragleave() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondragleave"]);
    }
      
        set ondragleave(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondragleave"] = V;
      }
      
        get ondragover() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondragover"]);
    }
      
        set ondragover(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondragover"] = V;
      }
      
        get ondragstart() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondragstart"]);
    }
      
        set ondragstart(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondragstart"] = V;
      }
      
        get ondrop() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondrop"]);
    }
      
        set ondrop(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondrop"] = V;
      }
      
        get ondurationchange() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ondurationchange"]);
    }
      
        set ondurationchange(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ondurationchange"] = V;
      }
      
        get onemptied() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onemptied"]);
    }
      
        set onemptied(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onemptied"] = V;
      }
      
        get onended() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onended"]);
    }
      
        set onended(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onended"] = V;
      }
      
        get onerror() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onerror"]);
    }
      
        set onerror(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onerror"] = V;
      }
      
        get onfocus() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onfocus"]);
    }
      
        set onfocus(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onfocus"] = V;
      }
      
        get oninput() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["oninput"]);
    }
      
        set oninput(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["oninput"] = V;
      }
      
        get oninvalid() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["oninvalid"]);
    }
      
        set oninvalid(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["oninvalid"] = V;
      }
      
        get onkeydown() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onkeydown"]);
    }
      
        set onkeydown(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onkeydown"] = V;
      }
      
        get onkeypress() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onkeypress"]);
    }
      
        set onkeypress(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onkeypress"] = V;
      }
      
        get onkeyup() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onkeyup"]);
    }
      
        set onkeyup(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onkeyup"] = V;
      }
      
        get onload() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onload"]);
    }
      
        set onload(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onload"] = V;
      }
      
        get onloadeddata() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onloadeddata"]);
    }
      
        set onloadeddata(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onloadeddata"] = V;
      }
      
        get onloadedmetadata() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onloadedmetadata"]);
    }
      
        set onloadedmetadata(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onloadedmetadata"] = V;
      }
      
        get onloadend() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onloadend"]);
    }
      
        set onloadend(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onloadend"] = V;
      }
      
        get onloadstart() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onloadstart"]);
    }
      
        set onloadstart(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onloadstart"] = V;
      }
      
        get onmousedown() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmousedown"]);
    }
      
        set onmousedown(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onmousedown"] = V;
      }
      
        get onmouseenter() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmouseenter"]);
    }
      
        set onmouseenter(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onmouseenter"] = V;
      }
      
        get onmouseleave() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmouseleave"]);
    }
      
        set onmouseleave(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onmouseleave"] = V;
      }
      
        get onmousemove() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmousemove"]);
    }
      
        set onmousemove(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onmousemove"] = V;
      }
      
        get onmouseout() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmouseout"]);
    }
      
        set onmouseout(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onmouseout"] = V;
      }
      
        get onmouseover() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmouseover"]);
    }
      
        set onmouseover(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onmouseover"] = V;
      }
      
        get onmouseup() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onmouseup"]);
    }
      
        set onmouseup(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onmouseup"] = V;
      }
      
        get onwheel() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onwheel"]);
    }
      
        set onwheel(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onwheel"] = V;
      }
      
        get onpause() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onpause"]);
    }
      
        set onpause(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onpause"] = V;
      }
      
        get onplay() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onplay"]);
    }
      
        set onplay(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onplay"] = V;
      }
      
        get onplaying() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onplaying"]);
    }
      
        set onplaying(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onplaying"] = V;
      }
      
        get onprogress() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onprogress"]);
    }
      
        set onprogress(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onprogress"] = V;
      }
      
        get onratechange() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onratechange"]);
    }
      
        set onratechange(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onratechange"] = V;
      }
      
        get onreset() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onreset"]);
    }
      
        set onreset(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onreset"] = V;
      }
      
        get onresize() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onresize"]);
    }
      
        set onresize(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onresize"] = V;
      }
      
        get onscroll() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onscroll"]);
    }
      
        set onscroll(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onscroll"] = V;
      }
      
        get onsecuritypolicyviolation() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onsecuritypolicyviolation"]);
    }
      
        set onsecuritypolicyviolation(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onsecuritypolicyviolation"] = V;
      }
      
        get onseeked() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onseeked"]);
    }
      
        set onseeked(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onseeked"] = V;
      }
      
        get onseeking() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onseeking"]);
    }
      
        set onseeking(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onseeking"] = V;
      }
      
        get onselect() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onselect"]);
    }
      
        set onselect(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onselect"] = V;
      }
      
        get onstalled() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onstalled"]);
    }
      
        set onstalled(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onstalled"] = V;
      }
      
        get onsubmit() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onsubmit"]);
    }
      
        set onsubmit(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onsubmit"] = V;
      }
      
        get onsuspend() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onsuspend"]);
    }
      
        set onsuspend(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onsuspend"] = V;
      }
      
        get ontimeupdate() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ontimeupdate"]);
    }
      
        set ontimeupdate(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ontimeupdate"] = V;
      }
      
        get ontoggle() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["ontoggle"]);
    }
      
        set ontoggle(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["ontoggle"] = V;
      }
      
        get onvolumechange() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onvolumechange"]);
    }
      
        set onvolumechange(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onvolumechange"] = V;
      }
      
        get onwaiting() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["onwaiting"]);
    }
      
        set onwaiting(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
      V = utils.tryImplForWrapper(V);
    
        esValue[implSymbol]["onwaiting"] = V;
      }
      
        get dataset() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.getSameObject(this, "dataset", () => { return utils.tryWrapperForImpl(esValue[implSymbol]["dataset"]); });
    }
      
        get nonce() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
          const value = esValue[implSymbol].getAttributeNS(null, "nonce");
          return value === null ? "" : value;
        
    }
      
        set nonce(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'nonce' property on 'HTMLElement': The provided value", });
      
        
          esValue[implSymbol].setAttributeNS(null, "nonce", V);
        
      }
      
        get tabIndex() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        return esValue[implSymbol]["tabIndex"];
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set tabIndex(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["long"](V, { context: "Failed to set the 'tabIndex' property on 'HTMLElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        esValue[implSymbol]["tabIndex"] = V;
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      }Object.defineProperties(HTMLElement.prototype, { click: { enumerable: true }, focus: { enumerable: true }, blur: { enumerable: true }, title: { enumerable: true }, lang: { enumerable: true }, translate: { enumerable: true }, dir: { enumerable: true }, hidden: { enumerable: true }, accessKey: { enumerable: true }, draggable: { enumerable: true }, offsetParent: { enumerable: true }, offsetTop: { enumerable: true }, offsetLeft: { enumerable: true }, offsetWidth: { enumerable: true }, offsetHeight: { enumerable: true }, style: { enumerable: true }, onabort: { enumerable: true }, onauxclick: { enumerable: true }, onblur: { enumerable: true }, oncancel: { enumerable: true }, oncanplay: { enumerable: true }, oncanplaythrough: { enumerable: true }, onchange: { enumerable: true }, onclick: { enumerable: true }, onclose: { enumerable: true }, oncontextmenu: { enumerable: true }, oncuechange: { enumerable: true }, ondblclick: { enumerable: true }, ondrag: { enumerable: true }, ondragend: { enumerable: true }, ondragenter: { enumerable: true }, ondragexit: { enumerable: true }, ondragleave: { enumerable: true }, ondragover: { enumerable: true }, ondragstart: { enumerable: true }, ondrop: { enumerable: true }, ondurationchange: { enumerable: true }, onemptied: { enumerable: true }, onended: { enumerable: true }, onerror: { enumerable: true }, onfocus: { enumerable: true }, oninput: { enumerable: true }, oninvalid: { enumerable: true }, onkeydown: { enumerable: true }, onkeypress: { enumerable: true }, onkeyup: { enumerable: true }, onload: { enumerable: true }, onloadeddata: { enumerable: true }, onloadedmetadata: { enumerable: true }, onloadend: { enumerable: true }, onloadstart: { enumerable: true }, onmousedown: { enumerable: true }, onmouseenter: { enumerable: true }, onmouseleave: { enumerable: true }, onmousemove: { enumerable: true }, onmouseout: { enumerable: true }, onmouseover: { enumerable: true }, onmouseup: { enumerable: true }, onwheel: { enumerable: true }, onpause: { enumerable: true }, onplay: { enumerable: true }, onplaying: { enumerable: true }, onprogress: { enumerable: true }, onratechange: { enumerable: true }, onreset: { enumerable: true }, onresize: { enumerable: true }, onscroll: { enumerable: true }, onsecuritypolicyviolation: { enumerable: true }, onseeked: { enumerable: true }, onseeking: { enumerable: true }, onselect: { enumerable: true }, onstalled: { enumerable: true }, onsubmit: { enumerable: true }, onsuspend: { enumerable: true }, ontimeupdate: { enumerable: true }, ontoggle: { enumerable: true }, onvolumechange: { enumerable: true }, onwaiting: { enumerable: true }, dataset: { enumerable: true }, nonce: { enumerable: true }, tabIndex: { enumerable: true }, [Symbol.toStringTag]: { value: "HTMLElement", configurable: true } });
        if (globalObject[ctorRegistrySymbol] === undefined) {
          globalObject[ctorRegistrySymbol] = Object.create(null);
        }
        globalObject[ctorRegistrySymbol][interfaceName] = HTMLElement;

        Object.defineProperty(globalObject, interfaceName, {
          configurable: true,
          writable: true,
          value: HTMLElement
        });
      };
    
    
        const Impl = require("../nodes/HTMLElement-impl.js");
      