
        "use strict";

        const conversions = require("webidl-conversions");
        const utils = require("./utils.js");
        
      const HTMLConstructor_helpers_html_constructor = require("../helpers/html-constructor.js").HTMLConstructor;
const parseURLToResultingURLRecord_helpers_document_base_url = require("../helpers/document-base-url.js").parseURLToResultingURLRecord;
const serializeURLwhatwg_url = require("whatwg-url").serializeURL;
const ceReactionsPreSteps_helpers_custom_elements = require("../helpers/custom-elements.js").ceReactionsPreSteps;
const ceReactionsPostSteps_helpers_custom_elements = require("../helpers/custom-elements.js").ceReactionsPostSteps;
const parseNonNegativeInteger_helpers_strings = require("../helpers/strings.js").parseNonNegativeInteger;
const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;
const HTMLElement = require("./HTMLElement.js");

      
      const interfaceName = "HTMLObjectElement";
    
      exports.is = function is(obj) {
        return utils.isObject(obj) && utils.hasOwn(obj, implSymbol) && obj[implSymbol] instanceof Impl.implementation;
      };
      exports.isImpl = function isImpl(obj) {
        return utils.isObject(obj) && obj instanceof Impl.implementation;
      };
      exports.convert = function convert(obj, { context = "The provided value" } = {}) {
        if (exports.is(obj)) {
          return utils.implForWrapper(obj);
        }
        throw new TypeError(`${context} is not of type 'HTMLObjectElement'.`);
      };
    
      exports.create = function create(globalObject, constructorArgs, privateData) {
        if (globalObject[ctorRegistrySymbol] === undefined) {
          throw new Error('Internal error: invalid global object');
        }

        const ctor = globalObject[ctorRegistrySymbol]["HTMLObjectElement"];
        if (ctor === undefined) {
          throw new Error('Internal error: constructor HTMLObjectElement is not installed on the passed global object');
        }

        let obj = Object.create(ctor.prototype);
        obj = exports.setup(obj, globalObject, constructorArgs, privateData);
        return obj;
      };
      exports.createImpl = function createImpl(globalObject, constructorArgs, privateData) {
        const obj = exports.create(globalObject, constructorArgs, privateData);
        return utils.implForWrapper(obj);
      };
      exports._internalSetup = function _internalSetup(obj, globalObject) {
    
        HTMLElement._internalSetup(obj, globalObject);
      
      };
      exports.setup = function setup(obj, globalObject, constructorArgs = [], privateData = {}) {
        privateData.wrapper = obj;

        exports._internalSetup(obj, globalObject);
        Object.defineProperty(obj, implSymbol, {
          value: new Impl.implementation(globalObject, constructorArgs, privateData),
          configurable: true
        });
    
        obj[implSymbol][utils.wrapperSymbol] = obj;
        if (Impl.init) {
          Impl.init(obj[implSymbol], privateData);
        }
        return obj;
      };
    
      exports.install = function install(globalObject) {
    
        if (globalObject.HTMLElement === undefined) {
          throw new Error('Internal error: attempting to evaluate HTMLObjectElement before HTMLElement');
        }
      class HTMLObjectElement extends globalObject.HTMLElement {
        constructor() {
      return HTMLConstructor_helpers_html_constructor(globalObject, interfaceName, new.target);
    }
      
        checkValidity() {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        if (!exports.is(esValue)) {
          throw new TypeError("Illegal invocation");
        }
      
        return esValue[implSymbol].checkValidity();
      }
      
        reportValidity() {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        if (!exports.is(esValue)) {
          throw new TypeError("Illegal invocation");
        }
      
        return esValue[implSymbol].reportValidity();
      }
      
        setCustomValidity(error) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        if (!exports.is(esValue)) {
          throw new TypeError("Illegal invocation");
        }
      
        if (arguments.length < 1) {
          throw new TypeError("Failed to execute 'setCustomValidity' on 'HTMLObjectElement': 1 argument required, but only " + arguments.length +
                              " present.");
        }
      const args = [];{ let curArg = arguments[0];
        curArg = conversions["DOMString"](curArg, { context: "Failed to execute 'setCustomValidity' on 'HTMLObjectElement': parameter 1", });
      args.push(curArg);}
        return esValue[implSymbol].setCustomValidity(...args);
      }
      
        get data() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "data");
          if (value === null) {
            return "";
          }
          const urlRecord = parseURLToResultingURLRecord_helpers_document_base_url(value, esValue[implSymbol]._ownerDocument);
          if (urlRecord !== null) {
            return serializeURLwhatwg_url(urlRecord);
          }
          return conversions.USVString(value);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set data(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["USVString"](V, { context: "Failed to set the 'data' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "data", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get type() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "type");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set type(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'type' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "type", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get name() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "name");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set name(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'name' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "name", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get useMap() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "usemap");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set useMap(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'useMap' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "usemap", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get form() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["form"]);
    }
      
        get width() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "width");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set width(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'width' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "width", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get height() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "height");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set height(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'height' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "height", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get contentDocument() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["contentDocument"]);
    }
      
        get willValidate() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["willValidate"];
    }
      
        get validity() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["validity"]);
    }
      
        get validationMessage() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["validationMessage"];
    }
      
        get align() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "align");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set align(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'align' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "align", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get archive() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "archive");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set archive(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'archive' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "archive", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get code() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "code");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set code(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'code' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "code", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get declare() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          return esValue[implSymbol].hasAttributeNS(null, "declare");
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set declare(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["boolean"](V, { context: "Failed to set the 'declare' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          if (V) {
            esValue[implSymbol].setAttributeNS(null, "declare", "");
          } else {
            esValue[implSymbol].removeAttributeNS(null, "declare");
          }
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get hspace() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          let value = esValue[implSymbol].getAttributeNS(null, "hspace");
          if (value === null) {
            return 0;
          }
          value = parseNonNegativeInteger_helpers_strings(value);
          return value !== null && value >= 0 && value <= 2147483647 ? value : 0;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set hspace(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["unsigned long"](V, { context: "Failed to set the 'hspace' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const n = V <= 2147483647 ? V : 0;
          esValue[implSymbol].setAttributeNS(null, "hspace", String(n));
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get standby() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "standby");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set standby(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'standby' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "standby", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get vspace() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          let value = esValue[implSymbol].getAttributeNS(null, "vspace");
          if (value === null) {
            return 0;
          }
          value = parseNonNegativeInteger_helpers_strings(value);
          return value !== null && value >= 0 && value <= 2147483647 ? value : 0;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set vspace(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["unsigned long"](V, { context: "Failed to set the 'vspace' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const n = V <= 2147483647 ? V : 0;
          esValue[implSymbol].setAttributeNS(null, "vspace", String(n));
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get codeBase() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "codebase");
          if (value === null) {
            return "";
          }
          const urlRecord = parseURLToResultingURLRecord_helpers_document_base_url(value, esValue[implSymbol]._ownerDocument);
          if (urlRecord !== null) {
            return serializeURLwhatwg_url(urlRecord);
          }
          return conversions.USVString(value);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set codeBase(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'codeBase' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "codebase", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get codeType() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "codetype");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set codeType(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'codeType' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "codetype", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      
        get border() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          const value = esValue[implSymbol].getAttributeNS(null, "border");
          return value === null ? "" : value;
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
    }
      
        set border(V) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
        
        V = conversions["DOMString"](V, { context: "Failed to set the 'border' property on 'HTMLObjectElement': The provided value", });
      
        
      ceReactionsPreSteps_helpers_custom_elements(globalObject);
      try {
        
          esValue[implSymbol].setAttributeNS(null, "border", V);
        
      } finally {
        ceReactionsPostSteps_helpers_custom_elements(globalObject);
      }
    
      }
      }Object.defineProperties(HTMLObjectElement.prototype, { checkValidity: { enumerable: true }, reportValidity: { enumerable: true }, setCustomValidity: { enumerable: true }, data: { enumerable: true }, type: { enumerable: true }, name: { enumerable: true }, useMap: { enumerable: true }, form: { enumerable: true }, width: { enumerable: true }, height: { enumerable: true }, contentDocument: { enumerable: true }, willValidate: { enumerable: true }, validity: { enumerable: true }, validationMessage: { enumerable: true }, align: { enumerable: true }, archive: { enumerable: true }, code: { enumerable: true }, declare: { enumerable: true }, hspace: { enumerable: true }, standby: { enumerable: true }, vspace: { enumerable: true }, codeBase: { enumerable: true }, codeType: { enumerable: true }, border: { enumerable: true }, [Symbol.toStringTag]: { value: "HTMLObjectElement", configurable: true } });
        if (globalObject[ctorRegistrySymbol] === undefined) {
          globalObject[ctorRegistrySymbol] = Object.create(null);
        }
        globalObject[ctorRegistrySymbol][interfaceName] = HTMLObjectElement;

        Object.defineProperty(globalObject, interfaceName, {
          configurable: true,
          writable: true,
          value: HTMLObjectElement
        });
      };
    
    
        const Impl = require("../nodes/HTMLObjectElement-impl.js");
      