
        "use strict";

        const conversions = require("webidl-conversions");
        const utils = require("./utils.js");
        
      const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;

      
      const interfaceName = "MutationRecord";
    
      exports.is = function is(obj) {
        return utils.isObject(obj) && utils.hasOwn(obj, implSymbol) && obj[implSymbol] instanceof Impl.implementation;
      };
      exports.isImpl = function isImpl(obj) {
        return utils.isObject(obj) && obj instanceof Impl.implementation;
      };
      exports.convert = function convert(obj, { context = "The provided value" } = {}) {
        if (exports.is(obj)) {
          return utils.implForWrapper(obj);
        }
        throw new TypeError(`${context} is not of type 'MutationRecord'.`);
      };
    
      exports.create = function create(globalObject, constructorArgs, privateData) {
        if (globalObject[ctorRegistrySymbol] === undefined) {
          throw new Error('Internal error: invalid global object');
        }

        const ctor = globalObject[ctorRegistrySymbol]["MutationRecord"];
        if (ctor === undefined) {
          throw new Error('Internal error: constructor MutationRecord is not installed on the passed global object');
        }

        let obj = Object.create(ctor.prototype);
        obj = exports.setup(obj, globalObject, constructorArgs, privateData);
        return obj;
      };
      exports.createImpl = function createImpl(globalObject, constructorArgs, privateData) {
        const obj = exports.create(globalObject, constructorArgs, privateData);
        return utils.implForWrapper(obj);
      };
      exports._internalSetup = function _internalSetup(obj, globalObject) {
    
      };
      exports.setup = function setup(obj, globalObject, constructorArgs = [], privateData = {}) {
        privateData.wrapper = obj;

        exports._internalSetup(obj, globalObject);
        Object.defineProperty(obj, implSymbol, {
          value: new Impl.implementation(globalObject, constructorArgs, privateData),
          configurable: true
        });
    
        obj[implSymbol][utils.wrapperSymbol] = obj;
        if (Impl.init) {
          Impl.init(obj[implSymbol], privateData);
        }
        return obj;
      };
    
      exports.install = function install(globalObject) {
    class MutationRecord {
        constructor() {
        throw new TypeError("Illegal constructor");
      }
      
        get type() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["type"];
    }
      
        get target() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.getSameObject(this, "target", () => { return utils.tryWrapperForImpl(esValue[implSymbol]["target"]); });
    }
      
        get addedNodes() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.getSameObject(this, "addedNodes", () => { return utils.tryWrapperForImpl(esValue[implSymbol]["addedNodes"]); });
    }
      
        get removedNodes() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.getSameObject(this, "removedNodes", () => { return utils.tryWrapperForImpl(esValue[implSymbol]["removedNodes"]); });
    }
      
        get previousSibling() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["previousSibling"]);
    }
      
        get nextSibling() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["nextSibling"]);
    }
      
        get attributeName() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["attributeName"];
    }
      
        get attributeNamespace() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["attributeNamespace"];
    }
      
        get oldValue() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["oldValue"];
    }
      }Object.defineProperties(MutationRecord.prototype, { type: { enumerable: true }, target: { enumerable: true }, addedNodes: { enumerable: true }, removedNodes: { enumerable: true }, previousSibling: { enumerable: true }, nextSibling: { enumerable: true }, attributeName: { enumerable: true }, attributeNamespace: { enumerable: true }, oldValue: { enumerable: true }, [Symbol.toStringTag]: { value: "MutationRecord", configurable: true } });
        if (globalObject[ctorRegistrySymbol] === undefined) {
          globalObject[ctorRegistrySymbol] = Object.create(null);
        }
        globalObject[ctorRegistrySymbol][interfaceName] = MutationRecord;

        Object.defineProperty(globalObject, interfaceName, {
          configurable: true,
          writable: true,
          value: MutationRecord
        });
      };
    
    
        const Impl = require("../mutation-observer/MutationRecord-impl.js");
      