
        "use strict";

        const conversions = require("webidl-conversions");
        const utils = require("./utils.js");
        
      const StorageEventInit = require("./StorageEventInit.js");
const Storage = require("./Storage.js");
const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;
const Event = require("./Event.js");

      
      const interfaceName = "StorageEvent";
    
      exports.is = function is(obj) {
        return utils.isObject(obj) && utils.hasOwn(obj, implSymbol) && obj[implSymbol] instanceof Impl.implementation;
      };
      exports.isImpl = function isImpl(obj) {
        return utils.isObject(obj) && obj instanceof Impl.implementation;
      };
      exports.convert = function convert(obj, { context = "The provided value" } = {}) {
        if (exports.is(obj)) {
          return utils.implForWrapper(obj);
        }
        throw new TypeError(`${context} is not of type 'StorageEvent'.`);
      };
    
      exports.create = function create(globalObject, constructorArgs, privateData) {
        if (globalObject[ctorRegistrySymbol] === undefined) {
          throw new Error('Internal error: invalid global object');
        }

        const ctor = globalObject[ctorRegistrySymbol]["StorageEvent"];
        if (ctor === undefined) {
          throw new Error('Internal error: constructor StorageEvent is not installed on the passed global object');
        }

        let obj = Object.create(ctor.prototype);
        obj = exports.setup(obj, globalObject, constructorArgs, privateData);
        return obj;
      };
      exports.createImpl = function createImpl(globalObject, constructorArgs, privateData) {
        const obj = exports.create(globalObject, constructorArgs, privateData);
        return utils.implForWrapper(obj);
      };
      exports._internalSetup = function _internalSetup(obj, globalObject) {
    
        Event._internalSetup(obj, globalObject);
      
      };
      exports.setup = function setup(obj, globalObject, constructorArgs = [], privateData = {}) {
        privateData.wrapper = obj;

        exports._internalSetup(obj, globalObject);
        Object.defineProperty(obj, implSymbol, {
          value: new Impl.implementation(globalObject, constructorArgs, privateData),
          configurable: true
        });
    
        obj[implSymbol][utils.wrapperSymbol] = obj;
        if (Impl.init) {
          Impl.init(obj[implSymbol], privateData);
        }
        return obj;
      };
    
      exports.install = function install(globalObject) {
    
        if (globalObject.Event === undefined) {
          throw new Error('Internal error: attempting to evaluate StorageEvent before Event');
        }
      class StorageEvent extends globalObject.Event {
        constructor(type) {
        
        if (arguments.length < 1) {
          throw new TypeError("Failed to construct 'StorageEvent': 1 argument required, but only " + arguments.length +
                              " present.");
        }
      const args = [];{ let curArg = arguments[0];
        curArg = conversions["DOMString"](curArg, { context: "Failed to construct 'StorageEvent': parameter 1", });
      args.push(curArg);}{ let curArg = arguments[1];
        curArg = StorageEventInit.convert(curArg, { context: "Failed to construct 'StorageEvent': parameter 2", });
      args.push(curArg);}
        return exports.setup(Object.create(new.target.prototype), globalObject, args);
      }
      
        initStorageEvent(type) {
        const esValue = this !== null && this !== undefined ? this : globalObject;
        if (!exports.is(esValue)) {
          throw new TypeError("Illegal invocation");
        }
      
        if (arguments.length < 1) {
          throw new TypeError("Failed to execute 'initStorageEvent' on 'StorageEvent': 1 argument required, but only " + arguments.length +
                              " present.");
        }
      const args = [];{ let curArg = arguments[0];
        curArg = conversions["DOMString"](curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 1", });
      args.push(curArg);}{ let curArg = arguments[1];
      if (curArg !== undefined) {
    
        curArg = conversions["boolean"](curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 2", });
      }
        else {
          curArg = false;
        }
      args.push(curArg);}{ let curArg = arguments[2];
      if (curArg !== undefined) {
    
        curArg = conversions["boolean"](curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 3", });
      }
        else {
          curArg = false;
        }
      args.push(curArg);}{ let curArg = arguments[3];
      if (curArg !== undefined) {
    
      if (curArg === null || curArg === undefined) {
        curArg = null;
      } else {
    
        curArg = conversions["DOMString"](curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 4", });
      }}
        else {
          curArg = null;
        }
      args.push(curArg);}{ let curArg = arguments[4];
      if (curArg !== undefined) {
    
      if (curArg === null || curArg === undefined) {
        curArg = null;
      } else {
    
        curArg = conversions["DOMString"](curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 5", });
      }}
        else {
          curArg = null;
        }
      args.push(curArg);}{ let curArg = arguments[5];
      if (curArg !== undefined) {
    
      if (curArg === null || curArg === undefined) {
        curArg = null;
      } else {
    
        curArg = conversions["DOMString"](curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 6", });
      }}
        else {
          curArg = null;
        }
      args.push(curArg);}{ let curArg = arguments[6];
      if (curArg !== undefined) {
    
        curArg = conversions["USVString"](curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 7", });
      }
        else {
          curArg = "";
        }
      args.push(curArg);}{ let curArg = arguments[7];
      if (curArg !== undefined) {
    
      if (curArg === null || curArg === undefined) {
        curArg = null;
      } else {
    
        curArg = Storage.convert(curArg, { context: "Failed to execute 'initStorageEvent' on 'StorageEvent': parameter 8", });
      }}
        else {
          curArg = null;
        }
      args.push(curArg);}
        return esValue[implSymbol].initStorageEvent(...args);
      }
      
        get key() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["key"];
    }
      
        get oldValue() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["oldValue"];
    }
      
        get newValue() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["newValue"];
    }
      
        get url() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return esValue[implSymbol]["url"];
    }
      
        get storageArea() {
      const esValue = this !== null && this !== undefined ? this : globalObject;
      
      if (!exports.is(esValue)) {
        throw new TypeError("Illegal invocation");
      }
    
      return utils.tryWrapperForImpl(esValue[implSymbol]["storageArea"]);
    }
      }Object.defineProperties(StorageEvent.prototype, { initStorageEvent: { enumerable: true }, key: { enumerable: true }, oldValue: { enumerable: true }, newValue: { enumerable: true }, url: { enumerable: true }, storageArea: { enumerable: true }, [Symbol.toStringTag]: { value: "StorageEvent", configurable: true } });
        if (globalObject[ctorRegistrySymbol] === undefined) {
          globalObject[ctorRegistrySymbol] = Object.create(null);
        }
        globalObject[ctorRegistrySymbol][interfaceName] = StorageEvent;

        Object.defineProperty(globalObject, interfaceName, {
          configurable: true,
          writable: true,
          value: StorageEvent
        });
      };
    
    
        const Impl = require("../events/StorageEvent-impl.js");
      